package sun.awt.windows;

import java.awt.Window;
import java.awt.Component;
import java.awt.peer.ComponentPeer;
import sun.awt.KeyboardFocusManagerPeerImpl;

final class WKeyboardFocusManagerPeer extends KeyboardFocusManagerPeerImpl
{
    private static final WKeyboardFocusManagerPeer inst;
    
    static native void setNativeFocusOwner(ComponentPeer p0);
    
    static native Component getNativeFocusOwner();
    
    static native Window getNativeFocusedWindow();
    
    public static WKeyboardFocusManagerPeer getInstance() {
        return WKeyboardFocusManagerPeer.inst;
    }
    
    private WKeyboardFocusManagerPeer() {
    }
    
    @Override
    public void setCurrentFocusOwner(Component component) {
        setNativeFocusOwner((component != null) ? component.getPeer() : null);
    }
    
    @Override
    public Component getCurrentFocusOwner() {
        return getNativeFocusOwner();
    }
    
    @Override
    public void setCurrentFocusedWindow(Window window) {
        throw new RuntimeException("not implemented");
    }
    
    @Override
    public Window getCurrentFocusedWindow() {
        return getNativeFocusedWindow();
    }
    
    public static boolean deliverFocus(Component component, Component component2, boolean b, boolean b2, long n, CausedFocusEvent.Cause cause) {
        return KeyboardFocusManagerPeerImpl.deliverFocus(component, component2, b, b2, n, cause, getNativeFocusOwner());
    }
    
    static {
        inst = new WKeyboardFocusManagerPeer();
    }
}
